//------------------------------------------------------------------------------ 
//     :
// -     2 .
//
// -       RW, RS, E   .
// -       V1[]       
//    0,   7812,5   .=128 .
// -       :
//                 7   6    5    4   3   2   1   0
//                [T] [RW] [RS] [E] [7] [6] [5] [4]
//   > T -    ,   7 (+0 ) -       
//   > RW - 1-, 0- ( 0),         .
//   > RS - 0- , 1-  (.    )
//   > E -    (1- )
//   > [7] [6] [5] [4] -     
//
// -   -   8     
//    HD44780,            
//        (     )  
//     
//        204 V2[80].          
//        .
// -            V2[]=>V1[]
//
// -            
//    (   ,    ).
//
//             ,  
//       -    .
//        .
//------------------------------------------------------------------------------ 
//       
#define BLINK_ON     0x0d        //  -  
#define LINE_ON      0x0e        //  -  
#define CUR_OFF      0x0c        //  

#define LCD_H        4
#define LCD_W        20

volatile BYTE V1[8];                    //    
volatile BYTE iV1=0;                    //      
volatile BYTE nV1=0;                    //     
volatile BYTE wV1=0;                    //         

//  ""       .
BYTE V2[85]={0x30, 0x30, 0x30, 0x20, 0x28, 0x06, 0x0e, 0x01, 'L', 'o', 'a', 'd', 'i', 'n', 'g', '.', '.', '.'};
volatile BYTE iV2=0;                    //    
volatile BYTE nV2=18;                   //     
volatile BYTE aV2;                      //   
volatile BYTE lV2;                      //          :
//                 
// ,           
volatile BYTE fc=0xff;
// fc=255    -   CUR_OFF
// 7b=1      -   BLINK_ON
// 7b=0      -   LINE_ON
// 10b       -    
// 65432b    -    

volatile struct VideoControl
  {
  BYTE                      // ,     
  s1:1,                     //    0  ()
  s2:1,                     //    1       
  s3:1,                     //    2       
  s4:1,                     //    3  ()
  d:1,                      //         0-, 1-
  t:1,                      // 0 -           
                            // 1 -     
  h:1;                      // 0 -      (   )
                            // 1 -      (    )
  }fv;
//------------------------------------------------------------------------------ 
#define mMn 29              //   
volatile BYTE rMn=0;        //       
                            // 0-  
                            // 1-    
volatile BYTE iMn=255;      //     -  
                            // 255 ,    
FCHAR _m0[]="I. 1";            // 1      ( )
FCHAR _m1[]="II. 2";           // 1      ( )
FCHAR _m2[]="III.";     // 1     
FCHAR _m3[]="IV. ";      // 1      
FCHAR _m4[]="V.";          // 1  
FCHAR _m5[]="1.";          // 2   (./.)
FCHAR _m6[]="2.";              // 2   
FCHAR _m7[]=") ";         // 3      
FCHAR _m8[]=") ";         // 3       
FCHAR _m9[]=") ";          // 3      
FCHAR _m10[]=") .";      // 3       
FCHAR _m11[]=") ";       // 3      
FCHAR _m12[]="3..";       // 2  
FCHAR _m13[]=")I1 ";          // 3     .       .  .
FCHAR _m14[]=")I1 ";         // 3     .       .  .
FCHAR _m15[]=")V1 ";          // 3          
FCHAR _m16[]=")I2 ";          // 3     .       .  .
FCHAR _m17[]=")I2 ";         // 3     .       .  .
FCHAR _m18[]=")V2 ";          // 3          
FCHAR _m19[]=")V12";               // 3    
FCHAR _m20[]=") 1";             // 3     1     
FCHAR _m21[]=") 2";             // 3     2     
FCHAR _m22[]=")T1";                // 3     1 
FCHAR _m23[]=")T2";                // 3     2 
FCHAR _m24[]=")T3";                // 3     
FCHAR _m25[]="VI.";             // 1  
FCHAR _m26[]="1. 1";           // 2     1 (   )
FCHAR _m27[]="2. 2";           // 2     2 (   )
FCHAR _m28[]="3. ";           // 2      ( ,   )
//  
FBYTE gMn[]={1, 1, 1, 1, 1,  2,  2,  3,  3,  3,  3,  3,  2,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  1,  2,  2,  2};

PGM_P PROGMEM Mn[mMn]=
  {
  _m0, _m1, _m2, _m3, _m4, _m5, _m6, _m7, _m8, _m9, _m10, _m11, _m12, _m13, _m14, _m15,
  _m16, _m17, _m18, _m19, _m20, _m21, _m22, _m23, _m24, _m25, _m26, _m27, _m28
  };
//------------------------------------------------------------------------------ 
FCHAR _t0[]="   ";
FCHAR _t1[]="v1.5.xxxx.24/05/2009";
FCHAR _t2[]="=xxxx I=xx.xx";
FCHAR _t3[]="  ";
FCHAR _t4[]="\x01\x02\x03\x04\x05\x06\x07";
FCHAR _t5[]="? ";
FCHAR _t6[]="?";
FCHAR _t7[]="?   ";
FCHAR _t8[]="? ";
FCHAR _t9[]="?";
FCHAR _t10[]="      ";
FCHAR _t11[]=" 1";
FCHAR _t12[]=" 2";
FCHAR _t13[]=" 3";
FCHAR _t14[]="  ";
FCHAR _t15[]=" ?";
FCHAR _t16[]=" 1 ";
FCHAR _t17[]=" 1 ";
FCHAR _t18[]=" 2 ";
FCHAR _t19[]=" 2 ";
FCHAR _t20[]="=";
FCHAR _t21[]=".";
FCHAR _t22[]=". ";

FCHAR _t23[]="  ";            // 0
FCHAR _t24[]=" I=0";              // 1
FCHAR _t25[]=" ";                 // 2
FCHAR _t26[]=" T>50\x04";          // 3
FCHAR _t27[]=" T>X\x04/";           // 4
FCHAR _t28[]=".30%  ";             // 5
FCHAR _t29[]=" Vmin";             // 6
FCHAR _t30[]="V12  <11";            // 7
FCHAR _t31[]=" ";              // 8
FCHAR _t32[]="V<Vmin 1 !!!";            // 9
FCHAR _t33[]=" I>5A";                 // 10
FCHAR _t34[]=" V>25.9";              // 11
FCHAR _t35[]=" user";              // 12
FCHAR _t36[]="V<Vmin 0 !!!";            // 13
FCHAR _t37[]=". V.";              // 14
FCHAR _t38[]=" ";             // 15
FCHAR _t39[]=" Vmax";             // 16
FCHAR _t40[]=" ";              // 17

FCHAR _t41[]="?";
FCHAR _t42[]="=";
FCHAR _t43[]="=";
FCHAR _t44[]="V12()=xxxxx\x05";
FCHAR _t45[]="..=";
FCHAR _t46[]="V1()=";
FCHAR _t47[]="V2()=";
FCHAR _t48[]="=";
FCHAR _t49[]="... ";
FCHAR _t50[]="...";
FCHAR _t51[]="P=";
FCHAR _t52[]="I1(A)=";
FCHAR _t53[]="I2(A)=";
FCHAR _t54[]="\x05";
FCHAR _t55[]="T.(\x04)=";
FCHAR _t56[]=".(\x04)=";
FCHAR _t57[]="T(\x04)=";
FCHAR _t58[]="T(\x04)=";
FCHAR _t59[]="=";
FCHAR _t60[]=" =";

FCHAR _t61[]=".(.)=";
FCHAR _t62[]="(\x07)=";
FCHAR _t63[]="ID =";
FCHAR _t64[]="- =";
FCHAR _t65[]=". (%)=";
FCHAR _t66[]="=";
FCHAR _t67[]="1()=";
FCHAR _t68[]="2()=";
FCHAR _t69[]=" 0 Vmin()=";
FCHAR _t70[]=" 1 Vmin()=";
FCHAR _t71[]=". Vmax()=";
FCHAR _t72[]=". Vmax()=";
FCHAR _t73[]=".dV()=";
FCHAR _t74[]="-dV()=";
FCHAR _t75[]="I.(%)=";
FCHAR _t76[]="I.(%)=";
FCHAR _t77[]="I.(%)=";
FCHAR _t78[]="I0(%)=";
FCHAR _t79[]="I.(%)=";
FCHAR _t80[]="Tmax(\x04)=";
FCHAR _t81[]="Vt(\x04/.)=";
FCHAR _t82[]=" (%)=";
FCHAR _t83[]="t(.)=";
FCHAR _t84[]="t(.)=";
FCHAR _t85[]=". V.()=";
FCHAR _t86[]="V.(A/.)=";
FCHAR _t87[]="t.(.)=";
FCHAR _t88[]="=";
FCHAR _t89[]=" !!!";
FCHAR _t90[]="T1(\x04)=";
FCHAR _t91[]="T2(\x04)=";
FCHAR _t92[]="E%=";



//------------------------------------------------------------------------------ 
PGM_P PROGMEM Wr[]=
  {
  _t0, _t1, _t2, _t3, _t4, _t5, _t6, _t7, _t8, _t9, _t10, _t11, _t12, _t13, _t14, _t15,
  _t16, _t17, _t18, _t19, _t20, _t21, _t22, _t23, _t24, _t25, _t26, _t27, _t28, _t29,
  _t30, _t31, _t32, _t33, _t34, _t35, _t36, _t37, _t38, _t39, _t40, _t41, _t42, _t43,
  _t44, _t45, _t46, _t47, _t48, _t49, _t50, _t51, _t52, _t53, _t54, _t55, _t56, _t57,
  _t58, _t59, _t60, _t61, _t62, _t63, _t64, _t65, _t66, _t67, _t68, _t69, _t70, _t71,
  _t72, _t73, _t74, _t75, _t76, _t77, _t78, _t79, _t80, _t81, _t82, _t83, _t84, _t85,
  _t86, _t87, _t88, _t89, _t90, _t91, _t92
  };
//------------------------------------------------------------------------------ 
//  
//   - 
// 0xFF -  
// 0     fc -  
//       fc=0xff -   CURSOR_OFF
//       7b=1    -   CURSOR_BLINK_ON
//       7b=0    -   CURSOR_LINE_ON
//       10b     -    
//       65432b  -    
// 100   fc=0xff -   CURSOR_OFF

// 1                -   
// 2                -   
// 3                -   
// 4                -   
// 5                -   
// 6    XY NN       -     XY  NN
// 7    XY NN KK    -   KK   XY     NN
// 8    XY NN KK    -   KK   XY    NN
// 9    XY MN KK    -   KK   XY FLOAT   M  N   
// 10   XY NN KK    -  - KK   XY
// 11   XY KK       -  - KK   XY
// 12   XY KK NT    -  KK    NT
// 20   XY KK       -   
// 21   XY KK       -    
// 14   XY na tt    -   na     
// 15   XY nt tt    -   nt     

// 16   XY TT       -   TT   XY
// 22   XY f        -   (f=1)   (f=0)   
// 17   XY MM       -   MM   XY
// 18               -  3-  
// 19               -  1-  

// tt =
//      tt=0  
//      tt=1  
//      tt=2  
//      tt=3  
//      tt=4 /50
//      tt=5 /10
// XY=X(5  )+Y(3  )


//      
#define XYL switch((XY)&7){case 0: fv.s1=1; break; case 1: fv.s2=1; break; case 2: fv.s3=1; break; case 3: fv.s4=1; break;}
//    n     p
#define SHABLON(n, p) {nSh=n; pSh=p; cSh=2; sSh.first=1;}
//    n     p
#define SH(n) {nSh=n; pSh=255; cSh=2; sSh.first=1;}
//   
#define MENU nSh=1; pSh=255; cSh=2; sSh.first=1;
//     
#define REFRESH_SHABLON cSh=2; sSh.first=1;
//      
#define REFR_SHABLON cSh=1;
//       
#define CURSOR(x, y, type) (type==CUR_OFF)?fc=255:fc=((y)&3)+(((x)&31)<<(2))+(type==BLINK_ON?128:0);
//           4  
#define FC(x) ((x)<<(2))+3+128;
//  XY  x  y
#define XYN(x, y) ((x)<<(3))+((y)&7)

volatile BYTE nSh=0;                //    
volatile BYTE pSh=255;              //   1/10     (255 -  )
volatile BYTE cSh;                  //  
volatile struct SSH
  {
  BYTE
  first:1,                          // first=1        
  per:1;                            // per=1    
  }sSh;
//------------------------------------------------------------------------------ 
//    
FCHAR _s0[]={1, 16, 0, 0, 
                16, 1, 1, 8, XYN(5, 1), 4, 0, 
                16, 3, 4, 11, XYN(12, 3), 1, 100, 255};
//  
FCHAR _s1[]={1, 18, 255};
//  " ?"
FCHAR _s2[]={4, 16, 3, 15, 255};
//   /   (        )
FCHAR _s3[]={1, 12, 0, 108, 16,
             16, 1, 52, 9, XYN(6, 1), 0x52, 101, 16, XYN(12, 1), 92, 9, XYN(15, 1), 0x51, 109,
             16, 2, 46, 9, XYN(6, 2), 0x52, 102, 11, XYN(12, 2), 104,
             16, 3, 90, 9, XYN(7, 3), 0x52, 103,
             100, 255};
//   /   (        )
FCHAR _s4[]={1, 12, 0, 208, 18,
             16, 1, 53, 9, XYN(6, 1), 0x52, 201, 16, XYN(12, 1), 92, 9, XYN(15, 1), 0x51, 209,
             16, 2, 47, 9, XYN(6, 2), 0x52, 202, 11, XYN(12, 2), 204,
             16, 3, 91, 9, XYN(7, 3), 0x52, 203,
             100, 255};
//   1  ( ,  , , )
FCHAR _s5[]={1, 12, 0, 107, 23,
             16, 1, 59, 20, XYN(4, 1), 100,
             16, 2, 92, 9, XYN(3, 2), 0x51, 109,
             11, XYN(12, 3), 104,
             100, 255};
//   2  ( ,  , , )
FCHAR _s6[]={1, 12, 0, 207, 23,
             16, 1, 59, 20, XYN(4, 1), 200,
             16, 2, 92, 9, XYN(3, 2), 0x51, 209,
             11, XYN(12, 3), 204,
             100, 255};
//   1   0 ( )
FCHAR _s9[]={5, 16, 3, 59, 20, XYN(4, 3), 100, 101, 255};
//   1   1 ( )
FCHAR _s10[]={5, 16, 3, 42, 12, XYN(9, 3), 105, 5, 101, 255};
//   1   2 ( )
FCHAR _s11[]={5, 16, 3, 43, 12, XYN(6, 3), 106, 10, 101, 255};
//   1   3 ( )
FCHAR _s12[]={5, 16, 3, 8, 101, 255};
//   1  ()
FCHAR _s13[]={3, 4, 5, 16, 3, 9, 101, 255};
//   2   0 ( )
FCHAR _s14[]={5, 16, 3, 59, 20, XYN(4, 3), 200, 101, 255};
//   2   1 ( )
FCHAR _s15[]={5, 16, 3, 42, 12, XYN(9, 3), 205, 5, 101, 255};
//   2   2 ( )
FCHAR _s16[]={5, 16, 3, 43, 12, XYN(6, 3), 206, 10, 101, 255};
//   2   3 ( )
FCHAR _s17[]={5, 16, 3, 8, 101, 255};
//  / 
FCHAR _s21[]={5, 16, 3, 20, 12, XYN(5, 3), 2, 21, 101, 255};
//   1  ()
FCHAR _s22[]={1, 12, 0, 8, 49, 
              16, 1, 48,   8, XYN(4, 1), 4, 10,     16, XYN(9, 1), 52,   9, XYN(15, 1), 82, 101, 
              16, 3, 46,   9, XYN(6, 3), 0x63, 102, 16, XYN(12, 3), 54,  9, XYN(13, 3), 0x53, 9, 100, 255};
//   2  ()
FCHAR _s23[]={1, 12, 0, 8, 49, 
              16, 1, 48,   8, XYN(4, 1), 4, 10,     16, XYN(9, 1), 53,   9, XYN(15, 1), 82, 201, 
              16, 3, 47,   9, XYN(6, 3), 0x63, 202, 16, XYN(12, 3), 54,  9, XYN(13, 3), 0x53, 9, 100, 255};
//    V12
FCHAR _s24[]={1, 12, 0, 8, 49, 
              16, 3, 44,   9, XYN(7, 3), 0x63, 3,   16, XYN(13, 3), 54,  9, XYN(14, 3), 0x53, 9, 100, 255};
//   
FCHAR _s25[]={5, 16, 3, 60, 7, XYN(14, 3), 1, 12, 101, 255};
//   1  ()  1     IV
FCHAR _s7[]={1, 12, 0, 8, 49, 
              16, 1, 48,  8, XYN(4, 1), 4, 10,     16, XYN(9, 1), 46,   9, XYN(15, 1), 82, 102, 
              16, 2, 51,  9, XYN(2, 2), 98, 115,   16, XYN(9, 2), 58,   9, XYN(15, 2), 82, 4, 
              16, 3, 52,  9, XYN(6, 3), 0x63, 101, 16, XYN(12, 3), 54,  9, XYN(13, 3), 0x53, 9, 100, 255};
//   2  ()  1     IV
FCHAR _s8[]={1, 12, 0, 8, 49, 
              16, 1, 48,  8, XYN(4, 1), 4, 10,     16, XYN(9, 1), 47,   9, XYN(15, 1), 82, 202, 
              16, 2, 51,  9, XYN(2, 2), 98, 215,   16, XYN(9, 2), 58,   9, XYN(15, 2), 82, 4, 
              16, 3, 53,  9, XYN(6, 3), 0x63, 201, 16, XYN(12, 3), 54,  9, XYN(13, 3), 0x53, 9, 100, 255};

//     
FCHAR _s18[]={5, 16, 3, 89, 101, 255};

//   
FCHAR _s26[]={1, 
              16, 0, 55, 7, XYN(10, 0), 3, 14,
              16, 1, 56, 7, XYN(10, 1), 3, 15,
              16, 2, 57, 7, XYN(10, 2), 3, 16,
              16, 3, 58, 9, XYN(7, 3), 0x51, 4, 16, XYN(12, 3), 54,  9, XYN(13, 3), 66, 9, 12, XYN(15, 2), 13, 21, 255};
//  1   
FCHAR _s19[]={5, 16, 3, 90, 9, XYN(7, 3), 0x51, 103, 16, XYN(12, 3), 54,  9, XYN(13, 3), 66, 9, 12, XYN(15, 2), 116, 21, 255};
//  2   
FCHAR _s20[]={5, 16, 3, 91, 9, XYN(7, 3), 0x51, 203, 16, XYN(12, 3), 54,  9, XYN(13, 3), 66, 9, 12, XYN(15, 2), 216, 21, 255};





//       
FCHAR _s27[]={5, 16, 3, 88, 22, XYN(4, 3), 1, 255};
//     
FCHAR _s28[]={5, 16, 3, 61, 14, XYN(17, 3), 11, 1, 255};
//  
FCHAR _s29[]={5, 16, 3, 62, 14, XYN(11, 3), 12, 5, 255};
//  
FCHAR _s30[]={5, 16, 3, 63, 14, XYN(7, 3), 13, 1, 255};
//   
FCHAR _s31[]={5, 16, 3, 64, 14, XYN(14, 3), 14, 1, 255};
//   
FCHAR _s32[]={5, 16, 3, 65, 14, XYN(15, 3), 15, 1, 255};

//        
FCHAR _s33[]={5, 16, 3, 88, 22, XYN(4, 3), 0, 255};
//  1
FCHAR _s34[]={5, 16, 3, 67, 15, XYN(3, 3), 10, 1, 15, XYN(8, 3), 10, 0, 255};
//  2
FCHAR _s35[]={5, 16, 3, 68, 15, XYN(3, 3), 11, 1, 15, XYN(8, 3), 11, 0, 255};
// V0 min
FCHAR _s36[]={5, 16, 3, 69, 15, XYN(15, 3), 12, 4, 255};
// V1 min
FCHAR _s37[]={5, 16, 3, 70, 15, XYN(15, 3), 13, 4, 255};
// Vdin max
FCHAR _s38[]={5, 16, 3, 71, 15, XYN(15, 3), 14, 4, 255};
// Vstat max
FCHAR _s39[]={5, 16, 3, 72, 15, XYN(14, 3), 15, 4, 255};
// dV 
FCHAR _s40[]={5, 16, 3, 73, 15, XYN(15, 3), 16, 1, 255};
// -dV delta
FCHAR _s41[]={5, 16, 3, 74, 15, XYN(17, 3), 17, 1, 255};
// I
FCHAR _s42[]={5, 16, 3, 75, 15, XYN(11, 3), 18, 1, 255};
// I
FCHAR _s43[]={5, 16, 3, 76, 15, XYN(11, 3), 19, 1, 255};
// I
FCHAR _s44[]={5, 16, 3, 77, 15, XYN(11, 3), 20, 1, 255};
// I0
FCHAR _s45[]={5, 16, 3, 78, 15, XYN(11, 3), 21, 1, 255};
// I
FCHAR _s46[]={5, 16, 3, 79, 15, XYN(12, 3), 22, 1, 255};
// T
FCHAR _s47[]={5, 16, 3, 80, 15, XYN(9, 3), 23, 1, 255};
// Vt
FCHAR _s48[]={5, 16, 3, 81, 15, XYN(12, 3), 24, 5, 255};
// 
FCHAR _s49[]={5, 16, 3, 82, 15, XYN(14, 3), 25, 1, 255};
// Pdes
FCHAR _s50[]={5, 16, 3, 83, 15, XYN(14, 3), 26, 1, 255};
// Tdes
FCHAR _s51[]={5, 16, 3, 84, 15, XYN(15, 3), 27, 1, 255};
// V
FCHAR _s52[]={5, 16, 3, 85, 15, XYN(15, 3), 28, 4, 255};
// Vi
FCHAR _s53[]={5, 16, 3, 86, 15, XYN(15, 3), 29, 1, 255};
// t
FCHAR _s54[]={5, 16, 3, 87, 15, XYN(15, 3), 30, 1, 255};

//      tt=0  
//      tt=1  
//      tt=2  
//      tt=3  
//      tt=4 /50
//      tt=5 /10

PGM_P PROGMEM Sh[]=
  {
  _s0, _s1, _s2, _s3, _s4, _s5, _s6, _s7, _s8, _s9, _s10, _s11, _s12, _s13, _s14,
  _s15, _s16, _s17, _s18, _s19, _s20, _s21, _s22, _s23, _s24, _s25, _s26, _s27, _s28,
  _s29, _s30, _s31, _s32, _s33, _s34, _s35, _s36, _s37, _s38, _s39, _s40, _s41, _s42,
  _s43, _s44, _s45, _s46, _s47, _s48, _s49, _s50, _s51, _s52, _s53, _s54
  };
//------------------------------------------------------------------------------ 
