//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//          
//      
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
typedef unsigned char BYTE;         //    
typedef unsigned short WORD;        //   2  - 
typedef prog_uchar FBYTE;           //   FLASH 
typedef prog_char FCHAR;            //   FLASH 
//------------------------------------------------------------------------------
#define ERB  eeprom_read_byte       //    EEPROM
#define ERS  eeprom_read_block      //    EEPROM
#define EWB  eeprom_write_byte      //    EEPROM
#define EWS  eeprom_write_block     //    EEPROM
#define FRB  pgm_read_byte          //    FLASH
#define FRW  pgm_read_word          //    FLASH
#define FRS  memcpy_P               //    FLASH
#define RRS  memcpyR                //    RAM
//------------------------------------------------------------------------------
// #define PWM1TOP  0xFFFF          //    1  1   2  (max  16 )
// #define PWM1TOP  0x7FFF          //    1  1   2  ( 15 )
// #define PWM1TOP  0x3FFF          //    1  1   2  ( 14 )
#define PWM1TOP  0x1FFF          //    1  1   2  ( 13 )

#define kLM35 0.01526               //    500./32768.

#define SEPICMAX  PWM1TOP           //     SEPIC =33%
#define PSecs     781               // Freq/8/256/10=781,25      1/10 .
#define PTimeOut  7                 //         8   COM-
// ((8+8)/38400)/(1/7812)=3.25   7 ,      ,   - 
//       8         38400 

//       
#define sch_I0      PINA_Bit0       //   1 
#define sch_V0      PINA_Bit1       //   1 
#define sch_T0      PINA_Bit2       //   1 
#define sch_I1      PINA_Bit3       //   2 
#define sch_V1      PINA_Bit4       //   2 
#define sch_T1      PINA_Bit5       //   2 
#define sch_V12     PINA_Bit6       //    
#define sch_TC      PINA_Bit7       //   

#define sch_C0      PORTB_Bit0      //       1 
#define sch_C1      PORTB_Bit1      //       2 
#define sch_S0      PINB_Bit2       //  
#define sch_S2      PINB_Bit3       //  
#define sch_S1      PINB_Bit4       //  
#define sch_MOSI    PORTB_Bit5      //  
#define sch_MISO    PORTB_Bit6      //  
#define sch_SCK     PORTB_Bit7      //  

#define sch_DB4     PORTC_Bit0      // 4    
#define sch_DB5     PORTC_Bit1      // 4    
#define sch_DB6     PORTC_Bit2      // 4    
#define sch_DB7     PORTC_Bit3      // 4    
#define sch_RS      PORTC_Bit4      // /  
#define sch_RW      PORTC_Bit5      //   /
#define sch_E       PORTC_Bit6      //    
#define sch_S3      PINC_Bit7       //  

#define sch_RXD     PIND_Bit0       // RS232 
#define sch_TXD     PORTD_Bit1      // RS232 
#define sch_D0      PORTD_Bit2      //       1 
#define sch_D1      PORTD_Bit3      //       2 
#define sch_PWM1    PORTD_Bit4      // 16           2 
#define sch_PWM0    PORTD_Bit5      // 16           1 
#define cool        PORTD_Bit6      //     
#define sch_BUZZ    PORTD_Bit7      //  

//      COM- (    )
#define U_NotAnderstand 0xF0        //   (  )
#define U_OK            0xE1        //   
#define U_CANCEL        0xD2        //   
#define U_UP            0xC3        //      
#define U_DOWN          0xB4        //      
#define U_GiveMeADC     0xA5        //    ADC
#define U_GiveMeScr     0x96        //    
#define U_ReadMemory    0x5A        //    
#define U_WriteMemory   0x4B        //  
#define U_GO            0x3C        //  / 
#define U_VAR           0x2D        //  
#define U_Set           0x1F        //  

//  1/10 
volatile WORD pSecs=PSecs;          //    
volatile long Secs=0;               //   1/10 
volatile BYTE Stad=0;               //       
volatile BYTE Izm=1;                //            
volatile BYTE Izm2=0;               //        
volatile BYTE LastKey;              //       
volatile float V12;                 //   
volatile float kv12;                //   V12
volatile float Tc;                  //  
volatile BYTE et1;                  //    1
volatile BYTE et2;                  //    2
volatile BYTE et3;                  //    3
volatile unsigned short etc1;       // (.)  
volatile unsigned short etc2;       // (.)  
volatile unsigned short etc3;       // (.)  
volatile float Pch;                 // 
volatile WORD crcFlash;             //    
volatile WORD tPWM;                 //     0  PWM1TOP, ..  ,    1  

volatile BYTE nTest=0;              //      ADC  =nTest-1 (0- )
volatile WORD Amin, Amax;           //              d
volatile WORD dA;                   // ((Amax-Amin)/2)*32        
volatile float fA;                  // dA     
volatile BYTE AdcOrder=0;           //     3 .   -  5 
volatile WORD Ad[8];                //      
volatile WORD Adc[8];               //      


volatile BYTE nSendIt=0;            //    
volatile BYTE nOutBuf=0;            //     COM    
volatile BYTE iOutBuf=0;            //     COM    
volatile BYTE OutBuf[101];          //     COM-
volatile BYTE iInBuf=0;             //     COM 
volatile BYTE InBuf[101];           //     COM-
volatile BYTE pTimeOut=0;           //      
volatile bool fIncoming=false;      // 0- 1-  
volatile bool fTran=false;          //  PC         (=,,)
volatile bool fReAsk=false;         //       ,  ,      PC 
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
// 
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//    
//       - 
#define PKey       156              //    1/50 .
#define KeyBufSize 5                //   
volatile BYTE KeyBuf[KeyBufSize];   //  
volatile BYTE iK0=0;                //     ( )
volatile BYTE iK1=0;                //     ( )
// iK0  iK1 ,    
//     KeyBuf[iK0]    
//   iK0   1,    KeyBufSize   0
//     iK0  iK1,      
//      KeyBuf[iK1], iK1++,  iK1   iK0
volatile BYTE pKey=PKey;            // 16 000 000 / 8 / 256 / 156 ~= 50    (   )
volatile BYTE KKey=0;               //    1/50  
volatile BYTE KCode=0;              //   
volatile bool fKey;                 //     
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
// 
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
#define PMuz       122              //    1/64 .
#define MUZ(m) {nMuz=m; fMuz=0;}

volatile BYTE nMuz;                 //   
volatile BYTE pMuz;                 //     
volatile BYTE iMuz;                 //      Muz[] (      )
volatile BYTE pnMuz;                //    
volatile BYTE ppMuz;                //    
volatile BYTE sMuz;                 //         
volatile BYTE fMuz=255;             //  0- 1- 2- 3-255- 

volatile BYTE Volume=1;             //  0-, 1-
volatile BYTE NewVolume=1;          //   
//      
volatile BYTE MS[5]=
            {
//          3,                      // 0 Start       //
//          1,                      // 1 Stop     //
//          7,                      // 2 Click     
//          6,                      // 3 Flame  
//          2                       // 4 Error    
            };
volatile BYTE MuzEdit;              //    
volatile BYTE MuzNew;               //                 

//     
#define  dMu    F_CPU/128/2        //    2,     
#define  do_    dMu/262+.5          // do 262 Hz
#define  dod    dMu/277+.5          // do# 277 Hz
#define  re     dMu/294+.5          // re 294 Hz
#define  red    dMu/311+.5          // re# 311 Hz
#define  mi     dMu/330+.5          // mi 330 Hz
#define  fa     dMu/349+.5          // fa 349 Hz
#define  fad    dMu/370+.5          // fa# 370 Hz
#define  sol    dMu/392+.5          // sol 392 Hz
#define  sold   dMu/415+.5          // sol# 415 Hz
#define  la     dMu/440+.5          // la 440 Hz
#define  lad    dMu/466+.5          // la# 466 Hz
#define  si     dMu/494+.5          // si 494 Hz
#define  do2    dMu/523+.5          // do2 523 Hz
#define  do2d   dMu/554+.5          // do2# 554 Hz
#define  re2    dMu/587+.5          // re2 587 Hz
#define  re2d   dMu/622+.5          // re2# 622 Hz
#define  mi2    dMu/659+.5          // mi2 659 Hz
#define  fa2    dMu/698+.5          // fa2 698 Hz
#define  fa2d   dMu/740+.5          // fa2# 740 Hz
#define  sol2   dMu/784+.5          // sol2 784 Hz
#define  sol2d  dMu/831+.5          // sol2# 831 Hz
#define  la2    dMu/880+.5          // la2 880 Hz
#define  la2d   dMu/932+.5          // la2# 932 Hz
#define  si2    dMu/988+.5          // si2 988 Hz

// 
//         
//        
//   16 -    
//   16  32 -   
//   32 -  
//         
// 1  17 = 1/64 .
// 2  18 = 1/32
// 3  19 = 1/16
// 4  20 = 1/8
// 5  21 = 1/4
// 6  22 = 1/2
// 7  23 = 1
// 8  24 = 2

#define  nM     9       //   
FBYTE Muz[]=
  {
// 0 7:40
  37, la, 5, mi, 3, la, mi, la, mi, la, do2, 5, la, 3, do2, la, do2, la, do2, mi2, 5, do2, 3, mi2, re2, 5, si, 3, re2, do2, 5, la, 3, do2, si, mi2, 0, 
// 1 karb
  16, la, do2, mi2, do2, la, re2, 5, sol, 3, si, re2, si, sol, do2, 0, 
// 2 murka
  25, la, la, sold, la, lad, la, sol, fa, mi, fa, mi, re, 5, re2, 3, re2, do2d, re2, mi2, re2, do2d, re2, mi2, 0, 
// 3 digger
  35, re2, do2, re2, lad, sol, lad, fa, 5, re2, 3, do2, re2, lad, sol, lad, fa, 5, re2, 3, mi2, fa2, mi2, fa2, re2, mi2, re2, mi2, do2, re2, do2, lad, do2, re2, 0,
// 4 Start
  11, do_, 3, 19, re, mi, fa, sol, la, si, 0,
// 5 Stop
  11, si, 3, 19, la, sol, fa, mi, re, do_, 0,
// 6 Termo
  11, do_, re, mi, do_, re, mi, do_, re, mi, 0,
// 7 Click
  3, si2, 0,
// 8 Error
  12, do_, 2, 21, re, do_, re, do_, re, do_, re, do_, re, 0,
  0};
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
