//******************************************************************************
//******************************************************************************
//******************************************************************************
//    
//******************************************************************************
//******************************************************************************
//******************************************************************************
//  SRAM  size  c
void StrF(BYTE *tg, BYTE c, BYTE size)
{
while(size--){tg[size]=c;}
}
//------------------------------------------------------------------------------ 
//  sr(SRAM)  tg(SRAM)  size
void memcpyR(BYTE *tg, const BYTE *sr, BYTE size)
{
while(size--){tg[size]=sr[size];}
}
//------------------------------------------------------------------------------ 
//   Wr(FLASH)  V2(SRAM)
void ToV2(BYTE XY, BYTE t, bool f)
{
PGM_P sr;
if(f)sr=(PGM_P)(FRW(&(Wr[t])));             //      FLASH
else sr=(PGM_P)(FRW(&(Mn[t])));             //      FLASH
BYTE tg=LCD_W*(XY&7)+(XY>>3);               //  V2   
char c;                                     // 
while(true)
  {
  c=FRB(sr++);                              //  
  if(!c)return;                             //  0  
  V2[tg++]=c;                               //   V2
  }
}
//------------------------------------------------------------------------------ 
//******************************************************************************
//******************************************************************************
//******************************************************************************
//  
//******************************************************************************
//******************************************************************************
//******************************************************************************
#define POLYNOM_8       0x18    //    8  CRC
#define POLYNOM_16      0xA001  //    16  CRC
//---------------------------------------------------------------------------
// 8-   
void CRC8(BYTE in, BYTE *crc)
{
for(BYTE i=0; i<8; i++)
  {
  if((in^(*crc))&0x01){*crc=(((*crc)^POLYNOM_8)>>1)|0x80; in=(in>>1)|0x80;}
  else {in>>=1; *crc>>=1;}
  }
}
//---------------------------------------------------------------------------
// 16-   
void CRC16(BYTE in, WORD *crc)
{
*crc^=(WORD)in;
for(BYTE i=0; i<8; i++)*crc=((*crc)&0x01)?((*crc)>>1)^POLYNOM_16:((*crc)>>1);
}
//---------------------------------------------------------------------------
//    
WORD CrcFlash(void)
{
WORD r=0xffff;
for(WORD i=0; i<0x4000; i++)CRC16(FRB(i), &r);
return(r);
}
//------------------------------------------------------------------------------ 
//          
BYTE CrcBuf(BYTE *Sr, BYTE len)
{
BYTE r=0xff;
for(BYTE i=0; i<len; i++)CRC8(Sr[i], &r);
return(r);
}
//------------------------------------------------------------------------------ 
//          
bool CrcBufCheck(BYTE *Sr, BYTE len)
{
BYTE r=0xff;
for(BYTE i=0; i<len-1; i++)CRC8(Sr[i], &r);
return(r==Sr[len-1]);
}
//------------------------------------------------------------------------------ 
//******************************************************************************
//******************************************************************************
//******************************************************************************
//  
//******************************************************************************
//******************************************************************************
//******************************************************************************
//     
// 0-BYTE 1-WORD 2-LONG 3-FLOAT 255-1 254-0
void *GetKK(BYTE n, BYTE &h)
{
switch(n)
  {
//    
  case 0:  h=1; return((void*)(&crcFlash));     //     WORD
  case 1:  h=1; return((void*)(&Secs));         //    
  case 2:  h=0; return((void*)(&NewVolume));    //  /
  case 3:  h=3; return((void*)(&V12));          //  V12
  case 4:  h=3; return((void*)(&Tc));           //  
  case 5:  h=3; return((void*)(&kv12));         //   V12
  case 8:  h=0; return((void*)(&Stad));         // 
  case 9:  h=3; return((void*)(&fA));           //   
  case 10: h=1; return((void*)(&tPWM));         //     0  PWM1TOP, ..  ,    1  
  case 11: h=0; return((void*)(&MuzEdit));      //   
  case 12: h=0; return((void*)(&MuzNew));       //    
  case 13: h=0; return((void*)(&et3));          //  0- 1-
  case 14: h=0; return((void*)(&etc1));         // (.)  
  case 15: h=0; return((void*)(&etc2));         // (.)  
  case 16: h=0; return((void*)(&etc3));         // (.)  
  case 17: h=1; return((void*)(&Adc[0]));       // 32*I1
  case 18: h=1; return((void*)(&Adc[1]));       // 32*V1
  case 19: h=1; return((void*)(&Adc[2]));       // 32*T1
  case 20: h=1; return((void*)(&Adc[3]));       // 32*I2
  case 21: h=1; return((void*)(&Adc[4]));       // 32*V2
  case 22: h=1; return((void*)(&Adc[5]));       // 32*T2
  case 23: h=1; return((void*)(&Adc[6]));       // 32*V12
  case 24: h=1; return((void*)(&Adc[7]));       // 32*Tc
//  1   
  case 100: h=0; return((void*)(&Ch1.A));       //    
  case 101: h=3; return((void*)(&Ch1.I));       // 
  case 102: h=3; return((void*)(&Ch1.V));       // 
  case 103: h=3; return((void*)(&Ch1.T));       // 
  case 104: h=1; return((void*)(&Ch1.WTime));   //   
  case 105: h=0; return((void*)(&Ch1.Speed));   //  
  case 106: h=0; return((void*)(&Ch1.Cycl));    //  
  case 107: h=0; return((void*)(&Ch1.Msg));     //  
  case 108: h=254+Ch1.Zaryd; return((void*)0);  //   
  case 109: h=3; fA=Ch1.InZ/(360.*Ch1.Z); return((void*)(&fA)); //    %  
  case 110: h=3; return((void*)(&Ch1.k0));      //     
  case 111: h=3; return((void*)(&Ch1.k1));      //     
  case 112: h=3; return((void*)(&Ch1.k2));      //     
  case 115: h=3; Pch=Ch1.V*Ch1.I; return((void*)(&Pch));        // 
  case 116: h=0; return((void*)(&et1));         //   0- 1-
  case 117: h=3; return((void*)(&Ch1.kr0));     //     
  case 118: h=3; return((void*)(&Ch1.kr1));     //     
  case 119: h=3; return((void*)(&Ch1.kr2));     //     
  case 120: h=3; return((void*)(&Ch1.kv0));     //   
  case 121: h=3; return((void*)(&Ch1.kv1));     //   
  case 122: h=3; return((void*)(&Ch1.kv2));     //   
//  2   
  case 200: h=0; return((void*)(&Ch2.A));       //    
  case 201: h=3; return((void*)(&Ch2.I));       // 
  case 202: h=3; return((void*)(&Ch2.V));       // 
  case 203: h=3; return((void*)(&Ch2.T));       // 
  case 204: h=1; return((void*)(&Ch2.WTime));   //   
  case 205: h=0; return((void*)(&Ch2.Speed));   //  
  case 206: h=0; return((void*)(&Ch2.Cycl));    //   
  case 207: h=0; return((void*)(&Ch2.Msg));     //  
  case 208: h=254+Ch2.Zaryd; return((void*)0);  //   
  case 209: h=3; fA=Ch2.InZ/(360.*Ch2.Z); return((void*)(&fA)); //    %  
  case 210: h=3; return((void*)(&Ch2.k0));      //     
  case 211: h=3; return((void*)(&Ch2.k1));      //     
  case 212: h=3; return((void*)(&Ch2.k2));      //     
  case 215: h=3; Pch=Ch2.V*Ch2.I; return((void*)(&Pch));        // 
  case 216: h=0; return((void*)(&et2));         //   0- 1-
  case 217: h=3; return((void*)(&Ch2.kr0));     //     
  case 218: h=3; return((void*)(&Ch2.kr1));     //     
  case 219: h=3; return((void*)(&Ch2.kr2));     //     
  case 220: h=3; return((void*)(&Ch2.kv0));     //   
  case 221: h=3; return((void*)(&Ch2.kv1));     //   
  case 222: h=3; return((void*)(&Ch2.kv2));     //   
  }
return(0);
} 
//******************************************************************************
//******************************************************************************
//******************************************************************************
//  
//******************************************************************************
//******************************************************************************
//******************************************************************************
//------------------------------------------------------------------------------ 
//    (   )
BYTE FindMnUp(BYTE n)
{
if(!n || n==0xff)return(0xff);                  // 0xff -  
BYTE t=FRB(&gMn[n]);                            //    
while(true)
  {
  if(FRB(&gMn[--n])<t)return(n);
  if(!n)break;
  }
return(0xff);                                   //     (  )
}
//------------------------------------------------------------------------------ 
//       
WORD FindUpper(void)
{
if(!iMn)return(iMn);                            //     
BYTE rez=iMn;
for(int i=iMn-1; i>=0; i--)                     //  
  {
  if(FRB(&gMn[i])==FRB(&gMn[iMn]))rez=i;        //      
  if(FRB(&gMn[i])<FRB(&gMn[iMn]))break;         //       
  }
return(rez);
}
//------------------------------------------------------------------------------ 
//     
WORD FindLower(void)
{
if(iMn>=mMn-1)return(iMn);                      //       
BYTE rez=iMn;
for(BYTE i=iMn+1; i<mMn; i++)                   //  
  {
  if(FRB(&gMn[i])==FRB(&gMn[iMn]))rez=i;        //        
  if(FRB(&gMn[i])<FRB(&gMn[iMn]))break;         //       
  }
return(rez);
}
//******************************************************************************
//******************************************************************************
//******************************************************************************
//      
//******************************************************************************
//******************************************************************************
//******************************************************************************
//     
//  =   
// d = true  
// d = false  
// p = true  
// p = false   
// t = true    
// t = false     

//           tPA
//            tPTA
BYTE FindAT(BYTE a, bool d, bool p, bool t)
{
BYTE r=a;
do{
  if(d)a++;                                     //     
  else a--;                                     //    
  if(r==a)break;                                //   ,  
  if(t)                                         //   
    {
    if(a>=nA)continue;                          //    
    if(!p && ERB(&AE[a][11])==0xff)continue;    //   ,   , 
    break;                                      //   , 
    }
  else                                          //    
    {
    if(a>=nTA)continue;                         //     
    if(!p && ERB(&TAE[a][19])==0xff)continue;   //   ,   
    break;                                      //    
    }
  }while(true);                                 //  
if(a>=nA)return(a);                             //      (  )  ,    
if(t)                                           //   
  {
  if(ERB(&AE[a][11])==0xff)                     //    ,   
    {
    for(r=0; r<lA; r++)
      {
      if(r<6)tPA[r]='P'; 
      if(r==6 && a<10)tPA[r]=a+'0'; 
      if(r==6 && a>9)tPA[r]=a+'A'; 
      if(r>6 && r<10)tPA[r]=' '; 
      if(r>=10)tPA[r]=0;
      }
    ERS(tPTA, (BYTE*)&TAE[0][0], lTA);          //     
    }
  else                                          //   
    { 
    ERS(tPA, (BYTE*)&AE[a][0], lA);             //    
    ERS(tPTA, (BYTE*)&TAE[tPA[10]][0], lTA);    //     
    }
  }
else                                            //    
  {
  if(ERB(&TAE[a][19])==0xff)                    //    ,   
    for(r=0; r<lTA; r++)
      {
      if(r<6)tPTA[r]='P'; 
      if(r==6 && a<10)tPA[r]=a+'0'; 
      if(r==6 && a>9)tPA[r]=a+'A'; 
      if(r>6 && r<10)tPTA[r]=' '; 
      if(r>=10)tPTA[r]=0;
      }
  else                                          //   , 
    ERS(tPTA, (BYTE*)&TAE[a], lTA);             //    
  }
return(a);
}
//******************************************************************************
//******************************************************************************
//******************************************************************************
//   
//******************************************************************************
//******************************************************************************
//******************************************************************************
//         
bool InitCh(ZAR &ch)
{
nTest=0;
ch.STime=Secs;                                  //   
ch.SecsT=Secs;                                  //     10       

uint8_t *ea=&AE[ch.A][0];                       // EEPROM  
uint8_t *et=&TAE[ERB(ea+10)][0];                // EEPROM   

//      
//      
ch.Stop=false;                                  //  !
ch.ftPause=false;                               //      
ch.Msg=0;                                       //    
ch.T=0;                                         //     
ch.Told=0;                                      //     ,     
ch.dT=false;                                    //    
ch.Vmax=0;
ch.Vmaxs=0;                                     //      
ch.DP=ch.DPs=false;                             //     
ch.i=0;                                         //  
ch.iDec=0;                                      //    
ch.pDec=0;                                      //   
ch.sDec=0;                                      //   
ch.InZ=0;                                       //   0
ch.V=0;  
ch.Vst=0;                                       //   0
if(ch.First)                                    //     EEPROM   
  {
  ch.n=ERB(ea+11);                              //     
  ch.Z=ERB(ea+12)/10.;                          //  
  ch.f1=ERB(et+10);                             //  1  
  ch.f2=ERB(et+11);                             //  2  
  ch.PDec=ERB(et+26); if(ch.PDec<20)ch.PDec=20; //    
  ch.TDec=ERB(et+27); if(ch.TDec<5)ch.TDec=5;   //    
  ch.dV=ch.n*ERB(et+17)/1000.;                  //   
  ch.WW=ERB(et+29); if(ch.WW<10)ch.WW=10;       //     
  ch.Vmin0=ch.n*ERB(et+12)/50.;                 //     
  ch.Vmin1=ch.n*ERB(et+13)/50.;                 //     
  ch.Vh=ch.n*ERB(et+28)/50.;                    //  
  ch.Imin=ERB(et+18);                           //      
  ch.Imax=ERB(et+20);                           //      
  ch.Tmax=ERB(et+23);                           //    .
  ch.TT=ERB(et+24);                             //   /.
  ch.Fasa=1;                                    //     =    1 
  if(ch.f1&(1<<7))ch.Fasa=0;                    //    0  0
  }
ch.W=ch.WW;                                     //   
ch.Pause=10;                                    //  

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//             1
if(ch.Zaryd)    //  
  {
  ch.II=ch.Z*ERB(et+ch.Speed+18)/100.;          //    
  ch.VV=ch.n*ERB(et+14)/50.;                    //     
  //             
  //   , ..    1/  
  ch.CTime=360000000/(ERB(et+25)*ERB(et+ch.Speed+18));    //    1/10 
  }
else            //  
  {
  ch.II=ch.Z*ERB(et+20)/100.;                   //   
  ch.VV=ch.n*ERB(et+13)/50.;                    //    
  ch.CTime=360000000/(ERB(et+25)*ERB(et+20));   //    1/10 
  }

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//     0  2
//      N*(/)      
//       
if(!ch.Cycl)                                    //   
  {
  if(!ch.Fasa)      //   
    {
    ch.II=ch.Z*ERB(et+21)/100.;                 //       
    ch.CTime=ERB(et+30)*600;                    //   (      )
    }                                           //   ,        
  if(ch.Fasa==1 && (ch.f1&(1<<2)))              //   
    {
    ch.II=ch.Z*ERB(et+19)/100.;                 //    
    ch.IIDec=ch.Z*ERB(et+18)/100.;              //    
    ch.CTime=360000000*1.3/(ERB(et+25)*ERB(et+19));     //   30%   
    }
  if(ch.Fasa==2)    //   
    {
    ch.CTime=ERB(et+30)*600;                    //   (      )
    ch.II=ch.Z*ERB(et+22)/100.;                 //   
    ch.IIDec=ch.Z*ERB(et+22)/100.;              //  
    ch.dV=ch.n*ERB(et+16)/1000.;                //   dV  
    if((ch.f1&(1<<6)) && (ch.f1&(1<<5))){ch.Msg=15; return(false);}         //       
    if(!(ch.f1&(1<<6)) && !(ch.f1&(1<<5))){ch.Msg=15; return(false);}       //       
    }
  }
else                //       
  {                 //  0  2  (,    )       
  if((ch.f1&((1<<7)|(1<<6)|(1<<5)|(1<<2)))||(ch.f2&(1<<3)))
    {ch.Msg=15; return(false);}                 //        
  }
return(true);
}
//------------------------------------------------------------------------------
//     
// i -   0  0xfffe  
// z - =true, =false
// f -      

//     0  0xFFFF
//   OCR1AH*256+OCR1AL  OCR1BH*256+OCR1BL
//     ,     1
//     ,  0

//     494     ,
//      , ,  ""   " " 
// -  (   494 16/300 ~= 53 ).
// ..        /       .

//       ,  ,     .
//  ,   =0 ()       (),    .
void SetI(ZAR &ch, WORD i, bool z, bool f)
{
if(f && i>SEPICMAX)i=SEPICMAX;                  //    !!!
ch.i=i;
if(&ch==&Ch1)       //   
  {
  if(ch.Msg==10 || ch.Msg==11){OCR1AH=0xff; OCR1AL=0xff; sch_C0=0; sch_D0=0; return;}
  i=(~i)&PWM1TOP;                               //      
  OCR1AH=BYTE((i>>8)&0xff);                     //   
  OCR1AL=BYTE(i&0xff);                          //   
  if(f){if(z){sch_C0=1; sch_D0=0;} else {sch_C0=0; sch_D0=1;}}
  else{sch_C0=0; sch_D0=0;}
  }
else                //   
  {
  if(ch.Msg==10 || ch.Msg==11){OCR1BH=0xff; OCR1BL=0xff; sch_C1=0; sch_D1=0; return;}
  i=(~i)&PWM1TOP;                               //      
  OCR1BH=BYTE((i>>8)&0xff);                     //   
  OCR1BL=BYTE(i&0xff);                          //   
  if(f){if(z){sch_C1=1; sch_D1=0;} else {sch_C1=0; sch_D1=1;}}
  else{sch_C1=0; sch_D1=0;}
  }
}
//******************************************************************************
//******************************************************************************
//******************************************************************************
//  
//******************************************************************************
//******************************************************************************
//******************************************************************************
//------------------------------------------------------------------------------
//        
//    ()    =  1  PWM1TOP, ..
//    .
void Calc_tPWM(BYTE cod)
{
if(cod==13||cod==14||cod==15||cod==20)
  {tPWM=(WORD(OCR1AH))<<8; tPWM|=OCR1AL;}  //     1 
else
  {tPWM=(WORD(OCR1BH))<<8; tPWM|=OCR1BL;}  //     2 
tPWM=(~tPWM)&PWM1TOP;                      //     0  PWM1TOP, ..  ,    1  
}
//------------------------------------------------------------------------------
//  
// f=true 1 
// f=false 2-
void CalcI(bool f)
{
float ff;
if(f)
  {
  ff=float(Adc[0]);
  ff=Ch1.LZaryd?ff*(Ch1.k2*ff+Ch1.k1)+Ch1.k0:ff*(Ch1.kr2*ff+Ch1.kr1)+Ch1.kr0; 
  Ch1.I=ff>0?ff:0;
  ff=float(dA);
  if(nTest==1)fA=Ch1.LZaryd?ff*(Ch1.k2*ff+Ch1.k1):ff*(Ch1.kr2*ff+Ch1.kr1);
  }
else 
  {
  ff=float(Adc[3]);
  ff=Ch2.LZaryd?ff*(Ch2.k2*ff+Ch2.k1)+Ch2.k0:ff*(Ch2.kr2*ff+Ch2.kr1)+Ch2.kr0; 
  Ch2.I=ff>0?ff:0;
  ff=float(dA);
  if(nTest==4)fA=Ch2.LZaryd?ff*(Ch2.k2*ff+Ch2.k1):ff*(Ch2.kr2*ff+Ch2.kr1);
  }
}
//------------------------------------------------------------------------------
//  
// f=true 1 
// f=false 2-
void CalcV(bool f)
{
float ff;
if(f)
  {
  ff=float(Adc[1]);
  ff=ff*(Ch1.kv2*ff+Ch1.kv1)+Ch1.kv0;
  ff=Ch1.LZaryd?ff-Ch1.I*Ch1.Rch:ff; 
  Ch1.V=ff>0?ff:0;
  if(nTest==2)fA=float(dA)*Ch1.kv1;
  }
else
  {
  ff=float(Adc[4]);
  ff=ff*(Ch2.kv2*ff+Ch2.kv1)+Ch2.kv0;
  ff=Ch2.LZaryd?ff-Ch2.I*Ch2.Rch:ff;
  Ch2.V=ff>0?ff:0;
  if(nTest==5)fA=float(dA)*Ch2.kv1;
  }
}  
//------------------------------------------------------------------------------
//   
void StopChannels(void)
{
SetI(Ch1, 0, true, false);  //   1 
SetI(Ch2, 0, true, false);  //   2 
}
//------------------------------------------------------------------------------
// f -  
// x -     
// t -     
// z -    
void PrnFlo(float f, WORD x, BYTE t, BYTE z)
{
BYTE *y=(BYTE*)(x+t-1);         //     
bool s;                         //  
if(f<0){f=-f; s=1;}else s=0;    //  f       
for(BYTE i=0; i<z; i++)f*=10;   //   
WORD ff=f;                      // 
do{                             //         
  *y--=(ff%10)+'0';             //  
  ff/=10;                       //  
  t--;                          //   
  if(!(--z)){*y--='.'; t--;}    //        
  if(z&128 && !ff)break;        //   1        
  }while(t);                    //    
if(s&&t){*y--='-'; t--;}        //     
while(t--)*y--=' ';             //       float
}        
//------------------------------------------------------------------------------
// a -    
// x -     
// t - 
// m - 
void PrnInt(long a, WORD x, BYTE t, BYTE m)
{
BYTE *y=(BYTE*)(x+t-1);         //     
do{                             //      
  *y=(a%m)+'0';                 //  
  if(*y>'9')(*y)+=7;            //  ABCDEF
  y--;                          //    
  t--;                          //   
  a/=m;                         //  
  }while(a&&t);                 //    
if(m!=10)while(t--)*y--='0';    //     
else while(t--)*y--=' ';        //    
}
//------------------------------------------------------------------------------
// y -     
// a -   
// t=0  
// t=1  
// t=2  
// t=3  
// t=4 /50
// t=5 /10
void PrnPA(WORD y, BYTE a, BYTE t)
{
switch(t)
  {
  case 0:
    PrnInt(a, y, 8, 2);
    break;
  case 1:
    PrnInt(a, y, 3, 10);
    break;
  case 2:
    PrnInt(a, y, 2, 16);
    break;
  case 3:
    PrnFlo(a, y, 5, 2);
    break;
  case 4:
    PrnFlo(float(a)/50., y, 5, 2);
    break;
  case 5:
    PrnFlo(float(a)/10., y, 5, 2);
    break;
  }
}
//------------------------------------------------------------------------------
void TestMainParam(void)
{
V12=float(Adc[6])*kv12;                         //   5    15  (*15/32/1024)
if(V12<11.0)
  {
  Ch1.Msg=7;
  Ch2.Msg=7;                                    //    
  StopChannels();                               //   
  }
if(et3)Tc=float(Adc[7])*kLM35;                  //  
else Tc=25;
switch(etc1)
  {
  case 0:   cool=1; break;                      //   
  case 255: cool=0; break;                      //   
  default: 
    if(Tc>etc1)cool=1;                          //   
    if(Tc<etc2)cool=0;                          //  
  }
if(et3 && Tc>etc3)                              //        
  {
  Ch1.Msg=17;
  Ch2.Msg=17;                                   //   " "
  StopChannels();                               //   
  }
}
//******************************************************************************
//******************************************************************************
//******************************************************************************
